SystemOrganization addCategory: #Animation!

ImageMorph subclass: #Animation
	instanceVariableNames: 'formHolder animationOrder currentState'
	classVariableNames: 'TEST'
	poolDictionaries: ''
	category: 'Animation'!

!Animation classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 14:08'!
test

	^TEST! !

!Animation classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 14:08'!
test: aMorph

	TEST := aMorph! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:19'!
addForm: aForm
	formHolder add: aForm.! !

!Animation methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 2/2/2011 16:29'!
bar


"| spriter form line h an mask |
spriter := Spriter form: Animation test image.
form := spriter firstLine.
line := LineSpriter form: form.

mask := line findBiggerMask.
h := line splits.
h := h collect: [:ea | line centerSprite: ea usingMask: mask].

an := Animation new.
h do: [:each | an addForm: each].
an setAnimationTo: ({1.2.3.4.5.6} asOrderedCollection);inspect"! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 2/2/2011 13:49'!
foo

"
(ImageMorph new newForm: (Form fromFileNamed: 'a.png')).
Smalltalk garbageCollect
ImageMorph

Animation new
addForm: (Form fromFileNamed: 'p.png');
addForm: (Form fromFileNamed: 'Q.png');
setAnimationTo:( #(1 2 1 1 2 1 1 1 1 2 ) asOrderedCollection);
openInWorld. 

Animation new
addForm: (Form fromFileNamed: 'p.png') ;
addForm: (Form fromFileNamed: 'Q.png') ;
setAnimationTo:( #(1 1 1 2 1 2 1) asOrderedCollection);
openInWorld. 

f :=(Form fromFileNamed: 'FFVIIIMenuBattleSheet.png').

f :=(Form fromFileNamed: 'Shadow.gif').
color := (f colorAt: (0@0)).
f mapColor: color to: (Color transparent).
Animation new
addForm: (f) ;
setAnimationTo:( #(1) asOrderedCollection);
openInWorld. "

! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:41'!
initialize
	super initialize.
	animationOrder := OrderedCollection new.
	formHolder := OrderedCollection new.! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:44'!
resetAnimeState
	currentState := animationOrder copy.! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:44'!
setAnimationTo: aOrderedCollection
	animationOrder := aOrderedCollection.
	currentState:= animationOrder copy.
! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:23'!
step
	
	self image: (formHolder at: (currentState removeFirst)).
	currentState ifEmpty: [self resetAnimeState].! !

!Animation methodsFor: 'as yet unclassified' stamp: 'jb 1/31/2011 18:46'!
stepTime
	^250.! !

Object subclass: #Spriter
	instanceVariableNames: 'currentSprite maxMask currentIndex sprites'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animation'!

!Spriter commentStamp: 'BenjaminVanRyseghem 2/2/2011 15:34' prior: 0!
I sprite by line!

Spriter subclass: #LineSpriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Animation'!

!LineSpriter methodsFor: 'traitement' stamp: 'BenjaminVanRyseghem 2/2/2011 15:31'!
findBiggerMask
	"I search the bigger mask to be able to center the sprites later"
	
	^ self findBiggerMaskInRectangle: (0@0 corner: self currentSprite extent)! !

!LineSpriter methodsFor: 'traitement' stamp: 'BenjaminVanRyseghem 2/2/2011 15:58'!
splits


	^ self splitsInRectangle: (0@0 corner: self currentSprite extent)! !

!Spriter classSide methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
form: aForm

	^ self new currentSprite: aForm! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:27'!
backgroundColor

	^ self currentSprite colorAt: (0@0)! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 16:26'!
centerSprite: aColorForm usingMask: aRectangle
	"I return the sprite centered in a new sprite resized using aRectangle"
	
	| deltaX deltaY result |
	deltaX := ((aRectangle width - aColorForm width) / 2) asInteger.
	deltaY := ((aRectangle height - aColorForm height) / 2) asInteger.
	result := ColorForm extent: aRectangle extent depth: aColorForm depth.
	result colors: aColorForm colors.
	1 to: aColorForm width do: [:x |
		1 to: aColorForm height do: [:y |
			result colorAt: ((x+deltaX)@(y+deltaY)) put: (aColorForm colorAt: x@y)]].
	^result! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
currentIndex

	^ currentIndex! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
currentIndex: anObject

	currentIndex := anObject! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
currentSprite

	^ currentSprite! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
currentSprite: anObject

	currentSprite := anObject! !

!Spriter methodsFor: 'line' stamp: 'BenjaminVanRyseghem 2/2/2011 16:05'!
findBiggerMaskInRectangle: aRect
	"I search the bigger mask to be able to center the sprites later"
	
	| left right masks |
	masks := OrderedCollection new.
	right := 0.
	left := 0.
	[right = -1]
		whileFalse:[
			left := self foundNextVisibleColumnInRectangle: ((right@aRect top) corner: (aRect bottomRight -1)).
			right := self foundNextInvisibleColumnInRectangle: ((left@aRect top) corner: (aRect bottomRight -1)).
			(right = -1)
				ifTrue: [masks add: (aRect right - left)]
				ifFalse:[masks add: (right - left)]].			.
	^ (0@0 corner: (masks max)@(aRect height))! !

!Spriter methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/2/2011 15:59'!
firstLine
	
	| top bottom left right |
	top := self foundNextVisibleRawInRectangle: (0@0 corner: (self currentSprite extent -1)).
	bottom := self foundNextInvisibleRawInRectangle: (0@(top+1) corner: (self currentSprite extent -1)).
	left := self foundNextVisibleColumnInRectangle: (0@top corner: ((self currentSprite width -1)@bottom)).
	right := self foundLastVisibleColumnInRectangle: ((left+1)@top corner: ((self currentSprite width -1)@bottom)).

	^ self currentSprite copy: (left@top corner: right@bottom)! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:31'!
foundLastInvisibleColumnInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	right to: left by: -1 do: [:x || list |
		list := OrderedCollection new.
		top to: bottom do:[:y |
			list add: (tempImage colorAt: x@y)].
		(list allSatisfy: [:each | each = self backgroundColor])
			ifTrue: [^ x ]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:32'!
foundLastVisibleColumnInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	right to: left by: -1 do: [:x |
		top to: bottom do:[:y |
			((tempImage colorAt: x@y) = self backgroundColor)
				ifFalse: [^ x ]]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:32'!
foundNextInvisibleColumnInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	left to: right do: [:x || list |
		list := OrderedCollection new.
		top to: bottom do:[:y |
			list add: (tempImage colorAt: x@y)].
		(list allSatisfy: [:each | each = self backgroundColor])
			ifTrue: [^ x ]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:32'!
foundNextInvisibleRawInRectangle: aRect
	"In the rectangle aRect, I search for the next raw colored only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	top to: bottom do:[:y || colored |
		colored := false.
		left to: right do: [:x |
			((tempImage colorAt: x@y) = self backgroundColor)
				ifFalse: [colored := true]].
		colored ifFalse: [ ^ y ]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:32'!
foundNextVisibleColumnInRectangle: aRect
	"In the rectangle aRect, I search for the next column colored not only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	left to: right do: [:x |
		top to: bottom do: [:y |
			((tempImage colorAt: x@y) = self backgroundColor)
				ifFalse: [ ^ x ]]].
	^-1! !

!Spriter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/2/2011 15:33'!
foundNextVisibleRawInRectangle: aRect
	"In the rectangle aRect, I search for the next raw colored not only with the background color.
	The value returned is absolute"

	| right left bottom tempImage top |
	top := aRect top.
	right := aRect right.
	left := aRect left.
	bottom := aRect bottom.
	tempImage := self currentSprite.
	
	top to: bottom do: [:y |
		left to: right do: [:x |
			((tempImage colorAt: x@y) = self backgroundColor)
				ifFalse: [^ y ]]].
	^-1! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
maxMask

	^ maxMask! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
maxMask: anObject

	maxMask := anObject! !

!Spriter methodsFor: 'line' stamp: 'BenjaminVanRyseghem 2/2/2011 16:11'!
splitsInRectangle: aRect
	"I splite sprites in the rectangle"
	
	| rawSprites mask right left |
	rawSprites := OrderedCollection new.
	right := 0.
	left := 0.
	[right = -1]
		whileFalse:[
			left := self foundNextVisibleColumnInRectangle: ((right@aRect top) corner: (aRect bottomRight -1)).
			right := self foundNextInvisibleColumnInRectangle: ((left@aRect top) corner: (aRect bottomRight -1)).
			(right = -1)
				ifTrue: [mask := (left@aRect top) corner: ((aRect right)@aRect bottom)]
				ifFalse:[mask := (left@aRect top) corner: (right@aRect bottom)].
			rawSprites add: (self currentSprite copy: mask)].			.
	^ rawSprites! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
sprites

	^ sprites! !

!Spriter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2011 14:15'!
sprites: anObject

	sprites := anObject! !
